<?php

namespace Tool\Indexmenow\Controller;

Use Tool\Indexmenow\IndexMeNowPlugin;

class AdminController{

        public function __construct(){

            $this->init_hooks();
        }
        //initialize all hooks
        public function init_hooks(){
            add_action('admin_notices',[$this,'notice_error_apikey']);
            add_action('admin_menu', [$this,'indexMeNowMenu']);
            add_action( 'admin_post',[$this, 'save'] );
        }
            
        //add menu to the backoffice
        public function indexMeNowMenu(){
             add_menu_page('IndexMeNow','IndexMeNow', 'manage_options', 'index-me-now',array($this,'indexMeNowPage'),'dashicons-saved', 11);
        }

        // Display form to the page indexMeNow settings plugin 
        public function indexMeNowPage() {
            if (!current_user_can('manage_options')) {
                wp_die(__('You do not have the rights to access this page.'));
            }
            IndexMeNowPlugin::render('form-settings',[
            'title'=> __('Settings').': IndexMeNow.com (indexer)',
            'description' => __('Configuration of the','indexmenow').' <a href="http://indexmenow.com/" target="_blank">'.__('indexmenow.com','indexmenow').'</a>'. __(' plugin. This service allows you to index in a few minutes or hours the URLs of your site on Google.','indexmenow')
            ]);
        }

        //save data to options table
        public function save() {
            if ( ! (IndexMeNowPlugin::has_valid_nonce('auto-index-setting',$_POST['auto-index-setting'],'auto-index-save') && current_user_can( 'manage_options' ) ) ) {
                return;
            }
            if(!isset($_POST['auto-index']) || $_POST['auto-index'] == null){
                $check_auto_index = 'off';
                $date_check =0;
            }else{
                $check_auto_index = sanitize_text_field( $_POST['auto-index'] );
                $date_check  = date('Y-m-d');
            }
           

            $api_key = sanitize_text_field( $_POST['api-key'] );
            $checkapi = IndexMeNowPlugin::checkAccountIndexmenow($api_key);
            
            update_option( 'data_indexmenow_auto', $check_auto_index );
            update_option('data_indexmenow_date_autopub',$date_check);
            update_option( 'data_indexmenow_api', $api_key );
            update_option( 'statut_indexmenow_api',  $checkapi['statut_api'] );
            update_option( 'code_error_indexmenow_api',  $checkapi['error'] );
            update_option( 'credit_indexmenow_api',  $checkapi['credits'] );
  
            IndexMeNowPlugin::redirect();
        }

        //notify if error apikey
        public function notice_error_apikey(){
            
            $info_page = get_current_screen();
            $current_page = $info_page->parent_base;

            if($current_page =='index-me-now'){
                $api_key = get_option('data_indexmenow_api');
                $statut_api = get_option('statut_indexmenow_api');
                $error_code_api = get_option('code_error_indexmenow_api');
                $credits_dispo = get_option('credit_indexmenow_api');
                
                if($statut_api =='KO' && $error_code_api == 401){
                    IndexMeNowPlugin::render('notices',[
                        'message' => __('Invalid API key indexmenow.com : Check or insert your API key available on :','indexmenow').' <a href="https://tool.indexmenow.com/docapi" target="_blank"> https://tool.indexmenow.com/docapi</a>',
                        'class' => 'indexmenow_error'
                    ]);
                }else if($statut_api =='OK' && $error_code_api == '' && $credits_dispo != 0){
                    IndexMeNowPlugin::render('notices',[
                        'message' =>  __('Valid API key','indexmenow'),
                        'class' =>'indexmenow_success'
                    ]);
                }else if( $credits_dispo == 0 && $statut_api =='OK' && $error_code_api == ''){
                    IndexMeNowPlugin::render('notices',[
                        'message' => __('You don’t have enough credits. Reload your account','indexmenow'),
                        'class' => 'indexmenow_error'
                    ]);
                }
            }
        }


}