<?php

namespace Tool\Indexmenow\Controller;

Use Tool\Indexmenow\IndexMeNowPlugin;

class ManualButtonController{


    public function __construct(){

        $this->init_hooks();

    }

    public function init_hooks(){
        add_action('add_meta_boxes',[$this,'indexmenow_register_meta_boxes'],2);
        add_action('admin_enqueue_scripts',[$this,'indexmenow_scripts']);
        add_action('wp_ajax_indexmenow_execute', [$this,'indexmenow_execute']);
    }
   
   public function indexmenow_scripts(){
        wp_enqueue_style( 'indexmenow_button_css',plugins_url('../../assets/css/plugin-sidebar.css',__FILE__));
        wp_enqueue_script( 'indexmenow_button',plugins_url('../../assets/js/plugin-sidebar.js',__FILE__) , array( 'jquery' ), '1.0', true );
        wp_localize_script( 'indexmenow_button', 'ajax_object', [$this,'ajax_url'=>admin_url( 'admin-ajax.php' )]);
        wp_localize_script( 'indexmenow_button', 'ajax_object', [$this,'loading_img_url'=>plugins_url("../../assets/img/icon/loading.gif",__FILE__) ]);
    }
   
     //Add MetaBox Manual Button indexMeNow
     public function indexmenow_register_meta_boxes(){
        //var_dump(wp_get_current_user());
        add_meta_box( 'metaboxes_indexmenow', 'IndexMeNow.com', array($this,'indexmenow_display_callback'), null ,'side', 'high',
                array(
                    '__back_compat_meta_box' => true,
                )
        );
        
    }
    
    //Render Panel Metabox indexmenow
    public function indexmenow_display_callback() {

        $api_key = get_option('data_indexmenow_api');
        $statut_api = get_option('statut_indexmenow_api');
        $error_code_api = get_option('code_error_indexmenow_api');
        $credits_dispo = get_option('credit_indexmenow_api');
        $post_id = get_the_ID();

        $url = parse_url(get_site_url());
        $project_name =  $url['host'].' (plugin wordpress)';

        $index_auto_status = get_option('data_indexmenow_auto');

        if($index_auto_status == 'on'){
            $message_status_auto = __('Send automatically after publication :','indexmenow').' <strong>'.__('Yes').'</strong> <a href="'.menu_page_url('index-me-now',$echo = false).'" >'.__('Edit','indexmenow').'</a>';
        }else{
            $message_status_auto = __('Send automatically after publication :','indexmenow').' <strong>'.__('No').'</strong> <a href="'.menu_page_url('index-me-now',$echo = false).'" >'.__('Edit','indexmenow').'</a>';
        }
        
        if($api_key!=''){

            if($statut_api == 'KO' &&  $error_code_api == 401){
                IndexMeNowPlugin::render('error',['message'=> __('API Key indexmenow.com','indexmenow') .' : <strong>'.__('Error','indexmenow').'</strong> <br> <a href="'.menu_page_url('index-me-now',$echo = false).'">'.__('Corrected your API key','indexmenow').'</a>']);
            }else{
                IndexMeNowPlugin::render('manual-button',[
                'subtitle1' => __('Manual indexation :','indexmenow'),
                'subtitle_auto'=> __('Automatic indexing :','indexmenow'),
                'message_init'=>'<span class="indexmenow_success"><strong>'. __('Send this URL to Google for indexing or updating ?','indexmenow').' <br><br><a href="'.get_permalink($post_id).'" target="_blank" class="wrap_link">'.get_permalink($post_id).'</a></strong></span>',
                'message_error'=>'<span class="indexmenow_error"><strong>'. __('URL sent for indexing on ','indexmenow').' <a href="http://indexmenow.com/" target="_blank">indexmenow.com</a> </strong>'. __('in this project','indexmenow').' : '.$project_name.'</span>',
                'message_status_auto'=> $message_status_auto,
                'buttonchangetext' => 0
                ]);
            }
            
        }else{

             IndexMeNowPlugin::render('error',['message'=> __('API Key indexmenow.com','indexmenow').': <strong>'.__('Missing','indexmenow').'</strong> <br> <a href="'.menu_page_url('index-me-now',$echo = false).'">'. __('Add your API key','indexmenow').'</a>']);
        }
    }
    //Function sendLink to IndexMeNow
    public function sendLinkManually($post){

        $apikey = get_option('data_indexmenow_api');
        $url = parse_url(get_site_url());
        
        $name =  $url['host'].' (plugin wordpress)';
        $project_name = array('project_name' =>  $name);
        $args = array(
            'headers' => array(
                'Authorization' => 'Bearer '.$apikey,
            ),
            'body' => json_encode($project_name),
            'method'    => 'POST',

        );
     
        $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/project/exists',$args );
        
        $decode_data = json_decode($requete["body"]);
        
        $statut = $decode_data->status;
        
        

        if($statut =='OK'){
            
            $id_project = $decode_data->project_id;
        
            $urls = array('urls' => array(get_permalink($post->ID)) );
            
            $args = array(
            'headers' => array(
                'Authorization' => 'Bearer '.$apikey,
            ),
            'body' => json_encode($urls),
            'method'    => 'POST',
            );
        
            $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/project/'.$id_project.'/addurls',$args );
            
            return $id_project;
          
        }else{

            $data = array(
                'project_name' => $name,
                'urls' => array(get_permalink($post->ID))
            );

            $args = array(
                'headers' => array(
                    'Authorization' => 'Bearer '.$apikey,
                ),
                'body' => json_encode($data),
                'method'    => 'POST',
            );
            $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/project/add',$args );

            $requete_data = json_decode($requete["body"]);
            return $requete_data->project_id;
        }
    }
    //Execute Function sendLinkManually
    public function indexmenow_execute(){
  
        if ( ! (IndexMeNowPlugin::has_valid_nonce('nonce',$_POST['nonce'],'manual-indexmenow-save') ) ) {
            return;
        }

        $apikey = get_option('data_indexmenow_api');
        $post_id = sanitize_text_field($_POST['post_id']);
        $post = get_post($post_id);
        $update_credits = IndexMeNowPlugin::checkAccountIndexmenow($apikey);
        $url = parse_url(get_site_url());
        $project_name =  $url['host'].' (plugin wordpress)';
        $url_api = 'https://tool.indexmenow.com/project';
        if($update_credits['credits'] > 0){

            if($post->post_status =='publish'){  
                $id_project = $this->sendLinkManually($post);
                update_post_meta($post_id,'manual_indexmenow',true);
                update_option( 'credit_indexmenow_api',  $update_credits['credits'] );
            }

            $result =[
                'message'=>'<span class="indexmenow_success"><strong>'. __('URL sent for indexing on ','indexmenow').'<a href="http://indexmenow.com/" target="_blank"> indexmenow.com </a></strong>'. __('in this project','indexmenow').' :<a href="'.$url_api.'/'.$id_project.'" target="_blank"> '.$project_name.'</a></span>',
                'statut' => 1,
                'buttonchangetext'=> 1
            ];
            return wp_send_json_success($result);
            exit();
           
        }else{
            var_dump( $update_credits);
            $result =[
                'message'=>'<span class="indexmenow_error"><strong>'. __('You don\'t have enough credits. Reload your account','indexmenow').'</strong></span>',
                'statut' => 0
            ];
            return wp_send_json_success($result);
            exit();
            
        }
       
    }


}