<?php

namespace Tool\Indexmenow\Controller;

Use Tool\Indexmenow\IndexMeNowPlugin;
    
Class SendLinkController{

    public function __construct(){

        $this->init_hooks();

    }
    public function init_hooks(){

        add_action('transition_post_status', [$this,'sendLinkToApi'], 10, 3 );
        add_action('publish_future_post', [$this,'sendLinkToApi'], 10, 3);
        add_action('admin_notices',[$this,'notice_insufficient_credit']);
    }
    //check status account Indexmenow
    public static function checkAccountIndexmenow($key){

        $apikey = $key;
        $args = array(
            'headers' => array(
                'Authorization' => 'Bearer '.$apikey,
            ),
            'method'    => 'POST'
        );

        $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/user/credits',$args);

        $body = wp_remote_retrieve_body($requete);
       
        $decode_data = json_decode($body);
        $response = [
            'statut_api' => $decode_data->status,
            'error' => (isset($decode_data->error)) ? $decode_data->error : false,
            'credits'=> $decode_data->credits
        ];
       
        return $response;

    }
    Public function notice_insufficient_credit(){
        if(get_transient('errors_credit')){
            if('post' == get_post_type() || 'page' == get_post_type()){
                IndexMeNowPlugin::render('notices',[
                    'message'=>__('You don\'t have enough credits. Reload your account','indexmenow')
                ]);
            }
        }
        delete_transient( 'errors_credit' );
    }
    // Send data to the api indexMeNow
     public function sendLinkToApi($new_status, $old_status, $post){
       
        //update_option( 'publication_planifier',   $old_status .'=>'.$new_status);

        if(get_option('data_indexmenow_auto') =='on' && get_option('data_indexmenow_api')){

            $apikey = get_option('data_indexmenow_api');
            $url = parse_url(get_site_url());
          
            if( ($old_status !='publish' && $new_status === 'publish') ) {
                
                $update_credits = IndexMeNowPlugin::checkAccountIndexmenow(get_option('data_indexmenow_api'));
                //update_option( 'planification_condition',   $new_status);

                if($update_credits['credits'] > 0){

                    $name =  $url['host'].' (plugin wordpress)';
                    $project_name = array('project_name' =>  $name);
                    $args = array(
                        'headers' => array(
                            'Authorization' => 'Bearer '.$apikey,
                        ),
                        'body' => json_encode($project_name),
                        'method'    => 'POST',
    
                    );
                    //update_option( 'planification_condition_credit',   $new_status);
    
                    $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/project/exists',$args );
                    
                    $decode_data = json_decode($requete["body"]);
                   
                    $statut = $decode_data->status;
    
                    if($statut =='OK'){
                        
                        $id_project = $decode_data->project_id;
                    
                        $urls = array('urls' => array(get_permalink($post->ID)) );
                        
                        $args = array(
                        'headers' => array(
                            'Authorization' => 'Bearer '.$apikey,
                        ),
                        'body' => json_encode($urls),
                        'method'    => 'POST',
                        );
                    
                        $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/project/'.$id_project.'/addurls',$args );
    
                    }else{
    
                        $data = array(
                            'project_name' => $name,
                            'urls' => array(get_permalink($post->ID))
                        );
                
                        $args = array(
                            'headers' => array(
                                'Authorization' => 'Bearer '.$apikey,
                            ),
                            'body' => json_encode($data),
                            'method'    => 'POST',
                        );
                        $requete = wp_remote_request('https://tool.indexmenow.com/api/v1/project/add',$args );
              
                    }
                    
                    update_post_meta( $post->ID,'manual_indexmenow', true);
                    update_option( 'credit_indexmenow_api',  $update_credits['credits'] );
                }else{
                    update_option( 'planification_condition_error',   $new_status);
                    set_transient('errors_credit',true);
                    //var_dump($update_credits);
                }
            
            }
        }
     }



}
   