
const { registerPlugin } = wp.plugins;
const { PluginDocumentSettingPanel} = wp.editPost;
const { Button ,Panel, PanelBody, PanelRow} = wp.components;
const { __ } = wp.i18n;

if(config.auto_index_activate =='on' && config.api_key_indexmenow !=''){
    
    wp.data.subscribe(function () {
        const currentPost = wp.data.select( 'core/editor' ).getCurrentPost()
        const isSavingPost = wp.data.select('core/editor').isSavingPost();
        const isPublishingPost = wp.data.select('core/editor').isPublishingPost()
        const isAutosavingPost = wp.data.select('core/editor').isAutosavingPost()
   
        if (isSavingPost && isPublishingPost && !isAutosavingPost) {
            console.log(currentPost)
                const params ={ 
                    method :'POST',
                }
                fetch('../wp-json/indexmenow/v1/api_indexmenow/'+currentPost.id,params)
                .then((response) => response.json())
                .then((responseData) => {
                    
                    if(responseData.data.credits > 0){
                        wp.data.dispatch('core/editor').editPost( {  meta: { manual_indexmenow: true }  } )
                        wp.data.dispatch('core/editor').editPost( {  meta: { indexmenow_id_project: responseData.data.id_project }  } )
                        wp.data.dispatch('core/editor').savePost();
                    }else{
                        wp.data.dispatch( 'core/notices' ).createNotice(
                            'error',
                                __('You don\'t have enough credits. Reload your account','indexmenow'),
                                {id:'erreur' ,isDismissible: false }
                        );
                    }
                })   
        }
      })

}


const handleClick = () =>{
  
    const currentPost = wp.data.select( 'core/editor' ).getCurrentPost()
    const params ={ 
        method :'POST',
    }
    fetch('../wp-json/indexmenow/v1/api_indexmenow/'+currentPost.id,params)
    .then((response) => response.json())
    .then((responseData) => {
        
        if(responseData.data.credits > 0){
            wp.data.dispatch('core/editor').editPost( {  meta: { manual_indexmenow: true }  } )
            wp.data.dispatch('core/editor').editPost( {  meta: { indexmenow_id_project: responseData.data.id_project }  } )
            wp.data.dispatch('core/editor').savePost();
            wp.data.dispatch( 'core/notices' ).createNotice(
                'success',
                     __('URL sent for indexing','indexmenow'),
                    {id:'erreur' ,isDismissible: false }
            );
            
        }else{
            wp.data.dispatch( 'core/notices' ).createNotice(
                'error',
                    __('You don\'t have enough credits. Reload your account','indexmenow'),
                    {id:'erreur' ,isDismissible: false }
            );
        }
    })
       
    
}
const button_manual = () =>{
    
  const isSavingPost = wp.data.select('core/editor').isSavingPost()
  const currentPost = wp.data.select( 'core/editor' ).getCurrentPost()
  const meta = wp.data.select('core/editor').getEditedPostAttribute('meta')
  const meta_id_project = meta['indexmenow_id_project']
  const url ='https://tool.indexmenow.com/project/'+ meta_id_project
  const url_project = <a href={url} target="_blank">{config.project_name}</a>
  const yesNo = (config.auto_index_activate =='on') ? __('Yes','indexmenow') : __('No','indexmenow')
  const notification_send_autoindex = (config.auto_index_activate =='on') ? __('Send automatically after publication :','indexmenow') : __('Send automatically after publication :','indexmenow')

  const config_url = <a href={config.admin_url_page_indexmenow} >{ __('Edit','indexmenow') }</a>
 
    if(config.api_key_indexmenow!='' && config.statut_indexmenow_api =='OK' ){

        if(currentPost.meta.manual_indexmenow ==true && currentPost.status == "publish" ){
           

            return( 
                <>
                   <p><strong>{ __('Manual indexation :','indexmenow') }</strong></p>
                   <p><span class="indexmenow_success"><strong>{ __('URL sent for indexing on ','indexmenow') } <a href="http://indexmenow.com/" target="_blank">indexmenow.com</a> { __('in this project','indexmenow') }  :  {url_project} </strong></span> </p>
                   <p class="text-right"><Button
                    isPrimary
                    isLarge
                    className="components-button indexmenow-panel"
                    onClick ={handleClick}
                    >
                    { __('Resend this URL','indexmenow') }
                    </Button></p> 
                    <p><strong>{ __('Automatic indexing :','indexmenow') }</strong></p>
                    <p>{notification_send_autoindex} <strong> {yesNo} </strong> {config_url} </p>
                </>
                
            )
            

        }else if(currentPost.status != "publish"){

                return(<span class="indexmenow_notices_gutenberg"><strong>{ __('You must publish the article or page in order to send the URL of the article to be indexed.','indexmenow') } </strong></span>)

        }else{
                return( 
                    <>
                       <p><strong>{ __('Manual indexation :','indexmenow') }</strong></p>
                       <p><span class="indexmenow_notices_gutenberg "><strong>{ __('Send this URL to Google for indexing or updating ?','indexmenow') }</strong><br/><a href={currentPost.link} class="wrap_link">{currentPost.link}</a></span></p>
                       <p class="text-right"><Button
                        isPrimary
                        isLarge
                        className="components-button indexmenow-panel"
                        onClick ={handleClick}
                    >
                        { __('Send this URL','indexmenow') }
                        </Button></p> 
                        <p><strong>{ __('Automatic indexing :','indexmenow') }</strong></p>
                        <p>{notification_send_autoindex} <strong> {yesNo} </strong> {config_url} </p>
                    </>
                    
                )

        }
    }else if(currentPost.status != "publish"){

        return(<span class="indexmenow_notices_gutenberg"><strong>{ __('You must publish the article or page in order to send the URL of the article to be indexed.','indexmenow') } </strong></span>)

    }else if(config.api_key_indexmenow!='' && config.statut_indexmenow_api =='KO' && config.code_error_indexmenow_api == 401){

        return(<span class="indexmenow_error"><strong>{ __('API KEY : Error','indexmenow') }<br/><a href={config.admin_url_page_indexmenow}>{ __('Corrected your API key','indexmenow') }</a></strong></span>)

    }else if(config.api_key_indexmenow == '' && config.statut_indexmenow_api == 'KO'){
        return(<span class="indexmenow_error"><strong>{ __('API KEY : Missing','indexmenow') }<br/><a href= {config.admin_url_page_indexmenow}>{ __('Add your API key','indexmenow') }</a></strong></span>)
    }
   

}

registerPlugin(
    'indexmenow-sidebar',{
        icon : 'saved',
        render: () => {
            return(
                <>
                  <PluginDocumentSettingPanel
                       name="indexmenow-panel"
                       title="IndexMeNow"
                       className="manual-button-indexmenow"
                  >
                        {button_manual}
                  </PluginDocumentSettingPanel>
                </>
            )
        }
    }
)
